// Target container for note to be modified
var notesTarget = null;
// Popover settings (Bootstrap customizations)
// ===========================================

$(function() {
    $(".meta-info").popover({
        container: 'body',
        placement: 'top',
        html: 'true',
        trigger: 'hover'
    });
});


// Call Path toggle
// ================

$(document).ready(function() {
    $('.toggle-call-path').click(function(e) {
        //      e.preventDefault();

        var call_path_row = $(this).attr("data-content");
        var table_id = "#" + call_path_row + "-call-path";

        $(table_id).toggle();

        $(this).next().toggleClass('active');
    });
});


// Laravel app form-delete button handling
// =======================================

$(document).ready(function() {
    $(".del-link").click(function(e) {
        e.preventDefault();
        $(this).parent("form").submit();
    });
});


// Audio playback
// ===========================================

$(document).ready(function() {
    $('.ss-play').click(function() {
        var $this = $(this),
            player = $this.children('audio').get(0);

        $this.toggleClass("ss-pause");

        if ($this.hasClass('ss-pause')) {
            player.play();
            playing = true;

            // check if player has had on end event
            // bound and bind it if it hasn't
            if (player.onended === null) {
                player.onended = function() {
                    playing = false;
                    $this.removeClass('ss-pause');
                };
            }

        } else {
            player.pause();
            playing = false;
        }
    });
});


// Note submission handling
// ========================================

$(document).ready(function() {
    var frm = $('#modal-note-add form');
    frm.submit(function(ev) {
        ev.preventDefault();
        $.ajax({
            type: frm.attr('method'),
            url: "/notes",
            data: frm.serialize(),
            success: function(result) {
                var node = Templates['note-view'](result);
                notesTarget.prepend(node);
                $('#modal-note-add').modal('hide');
            },
            error: function(result) {
                //alert('failure');
            },
            beforeSend: function() {
                frm.find('.btn').attr('disabled', 'disabled');
            },
            complete: function() {
                frm.find('.btn').removeAttr('disabled');
                frm.find('textarea').val('');
                $("#notes-count-" + $("#noteable_id_add").val()).html(parseInt($("#notes-count-" + $("#noteable_id_add").val()).html()) + 1)
            }
        });
    });
});

$(document).ready(function() {
    var frm = $('#modal-note-edit form');
    frm.submit(function(ev) {
        ev.preventDefault();
        $.ajax({
            type: frm.attr('method'),
            url: frm.attr('action'),
            data: frm.serialize(),
            success: function(result) {
                var newNode = Templates['note-view'](result),
                    note_id = frm.find('[name=note_id_edit]').val(),
                    node = $('div.single-note[data-id=' + note_id + ']');
                node.remove();
                notesTarget.prepend(newNode);
                notesTarget = null;
                $('#modal-note-edit').modal('hide');
            },
            error: function(result) {
                //alert('failure');
            },
            beforeSend: function() {
                frm.find('.btn').attr('disabled', 'disabled');
            },
            complete: function() {
                frm.find('.btn').removeAttr('disabled');
            }
        });
    });
});

$(document).ready(function() {
    var frm = $('#modal-note-delete form');
    frm.submit(function(ev) {
        ev.preventDefault();
        $.ajax({
            type: "delete",
            url: frm.attr('action'),
            data: frm.serialize(),
            success: function(result) {
                var note_id = frm.find('[name=note_id_delete]').val(),
                    node = $('div.single-note[data-id=' + note_id + ']');
                node.remove();
                $('#modal-note-delete').modal('hide');
            },
            error: function(result) {
                //alert('failure');
            },
            beforeSend: function() {
                frm.find('.btn').attr('disabled', 'disabled');
            },
            complete: function() {
                frm.find('.btn').removeAttr('disabled');
                $("#notes-count-" + $("#noteable_id_add").val()).html(parseInt($("#notes-count-" + $("#noteable_id_add").val()).html()) - 1)
            }
        });
    });
});

// Add and Add toggle button for Notes section
$(document).ready(function() {
    $('article.call-path-notes').delegate('.modal-note-add-toggle', 'click', function() {
        notesTarget = $(this).parent().siblings('.notes-content');
        $("#noteable_id_add").val($(this).data('id'));
        $("#noteable_type_add").val($(this).data('noteable_type_add'));
        $('#modal-note-add').modal('show');
    })
});

$(document).ready(function() {
    $('article.call-path-notes').delegate('.modal-note-edit-toggle', 'click', function() {
        notesTarget = $(this).parent().parent().parent().parent('.notes-content');
        $("#note_id_edit").val($(this).data('id'));
        $("#noteable_id_edit").val($(this).data('noteable_id_edit'));
        $("#note_body").val($(this).data('body'));
        $("#note_edit_info").html("Last updated: " + $(this).data('updated') + " by " + $(this).data('username'));
        var form = $('#modal-note-edit .message-notes-form');
        var action = form.attr('action');
        var matches = action.match(/\d+$/);
        if (matches) {
            var setId = action.replace(/\d+$/, $(this).data('id'))
            form.attr('action', setId);
        } else {
            form.attr('action', action += '/' + $(this).data('id'));
        }
        $('#modal-note-edit').modal('show');
    })
});

$(document).ready(function() {
    $('article.call-path-notes').delegate('.modal-note-delete-toggle', 'click', function() {
        $("#note_id_delete").val($(this).data('id'));
        $("#noteable_id_delete").val($(this).data('noteable_id_delete'));
        $("#note_body_delete").val($(this).data('body'));
        $("#note_delete_info").html("Last updated: " + $(this).data('updated') + " by " + $(this).data('username'));
        var form = $('#modal-note-delete .message-notes-form');
        var action = form.attr('action');
        var matches = action.match(/\d+$/);
        if (matches) {
            var setId = action.replace(/\d+$/, $(this).data('id'))
            form.attr('action', setId);
        } else {
            form.attr('action', action += '/' + $(this).data('id'));
        }
        $('#modal-note-delete').modal('show');
    })
});
////////

$(document).ready(function() {
    $(document).ready(function() {
        $('#sub-company-select').on('change', function() {
            document.location.href = $(this).val();
        });

        $('#interval-select').on('change', function() {
            document.location.href = $(this).val();
        });
    });
}); //end document.ready


// Toggle the User Form Alt Phone Type drop-down
// ========================================
$(document).ready(function() {
    $("#alt_phone_number").on('input', function() {
        $("#alt_phone_type").removeClass('hide');
    });
});


// Toggle Mobile User Access PIN input
$(document).ready(function() {
    $('#mobile-enabled').on('click', function() {
        if (this.checked) {
            $("#pin").prop('disabled', false);
            $('#pin').focus();
        } else {
            $("#pin").val('');
            $("#pin").prop('disabled', true);
        }
    });

    if ($('#mobile-enabled').is(':checked')) {
        $("#pin").prop('disabled', false);
    }
});

// Clear filter box
$(document).ready(function() {
    var clearFilter = $('#clear-filter'),
        filter = $('#filter');

    clearFilter.hide().on('click', function() {
        clearFilter.hide();
        filter.val('');
    });

    filter.on('focus', function() {
        clearFilter.show();
    }).on('blur', function() {
        if (filter.val() === '') {
            clearFilter.hide();
        }
    });
});

// Email preferences form
$(document).ready(function() {
    $('#email-never').on('click', function() {
        $(':checkbox').not(this).prop('disabled', this.checked);
        if (this.checked) {
            $(':checkbox').not(this).prop('checked', false);
        }
    });

    if ($('#email-never').prop('checked')) {
        $(':checkbox').not('#email-never').prop('disabled', true);
    }
});