class PagedDataFetcher extends DataFetcher {
	constructor(url, jQuery, batchSize = 25, batchSizeKey='count', offsetKey='offset') {
		super(url, jQuery);
		this.currentOffset = 0;
		this.batchSize = batchSize;
		this.batchSizeKey = batchSizeKey;
		this.offsetKey = offsetKey;
		this.completionHandler = null;
		this.failureHandler = null;
		this.params = null;
	}

	fetchPage(index, params, completionHandler, failureHandler) {
		this.params = params;
		this.completionHandler = completionHandler;
		this.failureHandler = failureHandler;

		params[this.batchSizeKey] = this.batchSize;
		params[this.offsetKey] = this.currentOffset = index;

		super.sendRequest(params, completionHandler, failureHandler);
	}

	fetchNextPage() {
		if (!this.params || !this.completionHandler || !this.failureHandler) {
			return;
		};

		this.currentOffset++;
		this.fetchPage(this.currentOffset, this.params, this.completionHandler, this.failureHandler);
	}

	fetchPreviousPage() {
	if (!this.params || !this.completionHandler || !this.failureHandler) {
			return;
		};

		this.currentOffset--;
		this.fetchPage(this.currentOffset, this.params, this.completionHandler, this.failureHandler);	
	}
}
