var $__Object = Object, $__getOwnPropertyNames = $__Object.getOwnPropertyNames, $__getOwnPropertyDescriptor = $__Object.getOwnPropertyDescriptor, $__getDescriptors = function(object) {
  var descriptors = {}, name, names = $__getOwnPropertyNames(object);
  for (var i = 0; i < names.length; i++) {
    var name = names[i];
    descriptors[name] = $__getOwnPropertyDescriptor(object, name);
  }
  return descriptors;
}, $__createClassNoExtends = function(object, staticObject) {
  var ctor = object.constructor;
  Object.defineProperty(object, 'constructor', {enumerable: false});
  ctor.prototype = object;
  Object.defineProperties(ctor, $__getDescriptors(staticObject));
  return ctor;
};
var DataFetcher = function() {
  'use strict';
  var $DataFetcher = ($__createClassNoExtends)({
    constructor: function(url, jQuery) {
      this.requestUrl = url;
      this.$ = jQuery;
      this.currentRequest = null;
    },
    sendRequest: function(params, completionHandler, failureHandler) {
      if (this.currentRequest) {
        this.currentRequest.abort();
      }
      this.currentRequest = $.ajax({
        url: this.requestUrl,
        data: params,
        success: completionHandler,
        timeout: 10000
      }).fail(failureHandler);
    }
  }, {});
  return $DataFetcher;
}();
Date.prototype.ONE_SECOND = 1000;
Date.prototype.ONE_MINUTE = Date.prototype.ONE_SECOND * 60;
Date.prototype.ONE_HOUR = Date.prototype.ONE_MINUTE * 60;
Date.prototype.ONE_DAY = Date.prototype.ONE_HOUR * 24;
Date.prototype.MAX_HOURS = 23;
Date.prototype.MAX_MINS = 59;
Date.prototype.MAX_SECS = 59;
Date.prototype.SECONDS_PER_MINUTE = 60;
Date.prototype.SECONDS_PER_HOUR = Date.prototype.SECONDS_PER_MINUTE * 60;
Date.prototype.SECONDS_PER_DAY = Date.prototype.SECONDS_PER_HOUR * 24;
Date.prototype.SUNDAY = 0;
Date.prototype.MONDAY = 1;
Date.prototype.TUESDAY = 2;
Date.prototype.WEDNESDAY = 3;
Date.prototype.THURSDAY = 4;
Date.prototype.FRIDAY = 5;
Date.prototype.SATURDAY = 6;
Date.prototype.SUNDAY_SHORT = 'Sun';
Date.prototype.MONDAY_SHORT = 'Mon';
Date.prototype.TUESDAY_SHORT = 'Tues';
Date.prototype.WEDNESDAY_SHORT = 'Wed';
Date.prototype.THURSDAY_SHORT = 'Thurs';
Date.prototype.FRIDAY_SHORT = 'Fri';
Date.prototype.SATURDAY_SHORT = 'Sat';
Date.prototype.JANUARY = 0;
Date.prototype.FEBRUARY = 1;
Date.prototype.MARCH = 2;
Date.prototype.APRIL = 3;
Date.prototype.MAY = 4;
Date.prototype.JUNE = 5;
Date.prototype.JULY = 6;
Date.prototype.AUGUST = 7;
Date.prototype.SEPTEMBER = 8;
Date.prototype.OCTOBER = 9;
Date.prototype.NOVEMBER = 10;
Date.prototype.DECEMBER = 11;
Date.prototype.JANUARY_SHORT = 'Jan';
Date.prototype.FEBRUARY_SHORT = 'Feb';
Date.prototype.MARCH_SHORT = 'Mar';
Date.prototype.APRIL_SHORT = 'Apr';
Date.prototype.MAY_SHORT = 'May';
Date.prototype.JUNE_SHORT = 'Jun';
Date.prototype.JULY_SHORT = 'Jul';
Date.prototype.AUGUST_SHORT = 'Aug';
Date.prototype.SEPTEMBER_SHORT = 'Sept';
Date.prototype.OCTOBER_SHORT = 'Oct';
Date.prototype.NOVEMBER_SHORT = 'Nov';
Date.prototype.DECEMBER_SHORT = 'Dec';
Date.prototype.startOfDay = function() {
  return new Date(this.getFullYear(), this.getMonth(), this.getDate());
};
Date.prototype.endOfDay = function() {
  var dayEnd = this.startOfDay();
  dayEnd.setSeconds(this.MAX_SECS);
  dayEnd.setMinutes(this.MAX_MINS);
  dayEnd.setHours(this.MAX_HOURS);
  return dayEnd;
};
Date.prototype.beginningOfDayOffsetByDays = function(dateOffset) {
  var result = this.startOfDay();
  result = new Date(result.getTime() + (this.ONE_DAY * dateOffset));
  return result;
};
Date.prototype.endOfDayOffsetByDays = function(dateOffset) {
  var result = this.endOfDay();
  result = new Date(result.getTime() + (this.ONE_DAY * dateOffset));
  return result;
};
Date.prototype.getTweleveHourTimeString = function() {
  var hours = this.getHours(), mins = this.getMinutes(), period = hours > 11 ? 'pm': 'am';
  hours = (hours % 12);
  if (hours === 0) {
    hours = 12;
  }
  if (mins < 10) {
    mins = '0' + mins;
  }
  return hours + ':' + mins + ' ' + period;
};
Date.prototype.getShortMonthString = function() {
  var month = this.getMonth();
  switch (month) {
    case this.JANUARY:
      return this.JANUARY_SHORT;
    case this.FEBRUARY:
      return this.FEBRUARY_SHORT;
    case this.MARCH:
      return this.MARCH_SHORT;
    case this.APRIL:
      return this.APRIL_SHORT;
    case this.MAY:
      return this.MAY_SHORT;
    case this.JUNE:
      return this.JUNE_SHORT;
    case this.JULY:
      return this.JULY_SHORT;
    case this.AUGUST:
      return this.AUGUST_SHORT;
    case this.SEPTEMBER:
      return this.SEPTEMBER_SHORT;
    case this.OCTOBER:
      return this.OCTOBER_SHORT;
    case this.NOVEMBER:
      return this.NOVEMBER_SHORT;
    case this.DECEMBER:
      return this.DECEMBER_SHORT;
  }
  ;
};
Date.prototype.getShortDayString = function() {
  var day = this.getDay();
  switch (day) {
    case this.SUNDAY:
      return this.SUNDAY_SHORT;
    case this.MONDAY:
      return this.MONDAY_SHORT;
    case this.TUESDAY:
      return this.TUESDAY_SHORT;
    case this.WEDNESDAY:
      return this.WEDNESDAY_SHORT;
    case this.THURSDAY:
      return this.THURSDAY_SHORT;
    case this.FRIDAY:
      return this.FRIDAY_SHORT;
    case this.SATURDAY:
      return this.SATURDAY_SHORT;
  }
  ;
};
var $__TypeError = TypeError, $__Object = Object, $__getOwnPropertyDescriptor = $__Object.getOwnPropertyDescriptor, $__getPrototypeOf = $__Object.getPrototypeOf, $__getPropertyDescriptor = function(object, name) {
  while (object !== null) {
    var result = $__getOwnPropertyDescriptor(object, name);
    if (result) return result;
    object = $__getPrototypeOf(object);
  }
  return undefined;
}, $__superDescriptor = function(proto, name) {
  if (!proto) throw new $__TypeError('super is null');
  return $__getPropertyDescriptor(proto, name);
}, $__superCall = function(self, proto, name, args) {
  var descriptor = $__superDescriptor(proto, name);
  if (descriptor) {
    if ('value'in descriptor) return descriptor.value.apply(self, args);
    if (descriptor.get) return descriptor.get.call(self).apply(self, args);
  }
  throw new $__TypeError("Object has no method '" + name + "'.");
}, $__getProtoParent = function(superClass) {
  if (typeof superClass === 'function') {
    var prototype = superClass.prototype;
    if (Object(prototype) === prototype || prototype === null) return superClass.prototype;
  }
  if (superClass === null) return null;
  throw new TypeError();
}, $__getOwnPropertyNames = $__Object.getOwnPropertyNames, $__getDescriptors = function(object) {
  var descriptors = {}, name, names = $__getOwnPropertyNames(object);
  for (var i = 0; i < names.length; i++) {
    var name = names[i];
    descriptors[name] = $__getOwnPropertyDescriptor(object, name);
  }
  return descriptors;
}, $__createClass = function(object, staticObject, protoParent, superClass, hasConstructor) {
  var ctor = object.constructor;
  if (typeof superClass === 'function') ctor.__proto__ = superClass;
  if (!hasConstructor && protoParent === null) ctor = object.constructor = function() {};
  var descriptors = $__getDescriptors(object);
  descriptors.constructor.enumerable = false;
  ctor.prototype = Object.create(protoParent, descriptors);
  Object.defineProperties(ctor, $__getDescriptors(staticObject));
  return ctor;
};
var PagedDataFetcher = function($__super) {
  'use strict';
  var $__proto = $__getProtoParent($__super);
  var $PagedDataFetcher = ($__createClass)({
    constructor: function(url, jQuery) {
      var batchSize = arguments[2] !== (void 0) ? arguments[2]: 25;
      var batchSizeKey = arguments[3] !== (void 0) ? arguments[3]: 'count';
      var offsetKey = arguments[4] !== (void 0) ? arguments[4]: 'offset';
      $__superCall(this, $__proto, "constructor", [url, jQuery]);
      this.currentOffset = 0;
      this.batchSize = batchSize;
      this.batchSizeKey = batchSizeKey;
      this.offsetKey = offsetKey;
      this.completionHandler = null;
      this.failureHandler = null;
      this.params = null;
    },
    fetchPage: function(index, params, completionHandler, failureHandler) {
      this.params = params;
      this.completionHandler = completionHandler;
      this.failureHandler = failureHandler;
      params[this.batchSizeKey] = this.batchSize;
      params[this.offsetKey] = this.currentOffset = index;
      $__superCall(this, $__proto, "sendRequest", [params, completionHandler, failureHandler]);
    },
    fetchNextPage: function() {
      if (!this.params || !this.completionHandler || !this.failureHandler) {
        return;
      }
      ;
      this.currentOffset++;
      this.fetchPage(this.currentOffset, this.params, this.completionHandler, this.failureHandler);
    },
    fetchPreviousPage: function() {
      if (!this.params || !this.completionHandler || !this.failureHandler) {
        return;
      }
      ;
      this.currentOffset--;
      this.fetchPage(this.currentOffset, this.params, this.completionHandler, this.failureHandler);
    }
  }, {}, $__proto, $__super, true);
  return $PagedDataFetcher;
}(DataFetcher);
